VTK: vtkCompositeMapperHelper2 Class Reference

| VTK 9.3.1

Public Types | Public Member Functions | Static Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
vtkCompositeMapperHelper2 Class Reference

Helper class for vtkCompositePolyDataMapper2 that is a subclass of vtkOpenGLPolyDataMapper. More...

`#include <vtkCompositeMapperHelper2.h>`

Inherits vtkOpenGLPolyDataMapperImplementation.

Collaboration diagram for vtkCompositeMapperHelper2:
[legend]

## Public Types
typedef vtkOpenGLPolyDataMapper | Superclass

## Public Member Functions
virtual vtkTypeBool | IsA (const char *type)
vtkCompositeMapperHelper2 * | NewInstance () const
void | PrintSelf (ostream &os, vtkIndent indent) override
void | SetParent (vtkCompositePolyDataMapper2 *p)
vtkCompositeMapperHelperData * | AddData (vtkPolyData *pd, unsigned int flatIndex)
void | RenderPiece (vtkRenderer *ren, vtkActor *act) override
| Implemented by sub classes. More...
std::vector< vtkPolyData * > | GetRenderedList () const
| Accessor to the ordered list of PolyData that we last drew. More...
void | ProcessSelectorPixelBuffers (vtkHardwareSelector *sel, std::vector< unsigned int > &pixeloffsets, vtkProp *prop) override
| allows a mapper to update a selections color buffers Called from a prop which in turn is called from the selector More...
virtual void | ProcessCompositePixelBuffers (vtkHardwareSelector *sel, vtkProp *prop, vtkCompositeMapperHelperData *hdata, std::vector< unsigned int > &mypixels)
void | ClearMark ()
void | RemoveUnused ()
bool | GetMarked ()
void | SetMarked (bool v)

## Static Public Member Functions
static vtkCompositeMapperHelper2 * | New ()
static vtkTypeBool | IsTypeOf (const char *type)
static vtkCompositeMapperHelper2 * | SafeDownCast (vtkObjectBase *o)

## Protected Member Functions
virtual vtkObjectBase * | NewInstanceInternal () const
void | UpdateCameraShiftScale (vtkRenderer *ren, vtkActor *actor) override
| handle updating shift scale based on pose changes More...
| vtkCompositeMapperHelper2 ()
| ~vtkCompositeMapperHelper2 () override
void | DrawIBO (vtkRenderer *ren, vtkActor *actor, int primType, vtkOpenGLHelper &CellBO, GLenum mode, int pointSize)
virtual void | SetShaderValues (vtkShaderProgram *prog, vtkCompositeMapperHelperData *hdata, size_t primOffset)
void | UpdateShaders (vtkOpenGLHelper &cellBO, vtkRenderer *ren, vtkActor *act) override
| Make sure appropriate shaders are defined, compiled and bound. More...
void | ReplaceShaderColor (std::map< vtkShader::Type, vtkShader * > shaders, vtkRenderer *ren, vtkActor *act) override
| Perform string replacements on the shader templates, called from ReplaceShaderValues. More...
bool | GetNeedToRebuildBufferObjects (vtkRenderer *ren, vtkActor *act) override
| Does the VBO/IBO need to be rebuilt. More...
void | BuildBufferObjects (vtkRenderer *ren, vtkActor *act) override
| Build the VBO/IBO, called by UpdateBufferObjects. More...
virtual void | AppendOneBufferObject (vtkRenderer *ren, vtkActor *act, vtkCompositeMapperHelperData *hdata, vtkIdType &flat_index, std::vector< unsigned char > &colors, std::vector< float > &norms)
void | BuildSelectionIBO (vtkPolyData *poly, std::vector< unsigned int >(&indices)[4], vtkIdType offset) override
| Build the selection IBOs, called by UpdateBufferObjects. More...
int | CanUseTextureMapForColoring (vtkDataObject *) override
| Returns if we can use texture maps for scalar coloring. More...
void | RenderPieceDraw (vtkRenderer *ren, vtkActor *act) override

## Protected Attributes
vtkCompositePolyDataMapper2 * | Parent
std::map< vtkPolyData *, vtkCompositeMapperHelperData * > | Data
bool | Marked
std::vector< unsigned int > | VertexOffsets
std::vector< unsigned int > | IndexArray [PrimitiveEnd]
bool | PrimIDUsed
bool | OverideColorUsed
vtkHardwareSelector * | CurrentSelector
std::vector< std::vector< unsigned int > > | PickPixels
| used by the hardware selector More...
std::map< vtkAbstractArray *, vtkDataArray * > | ColorArrayMap

## Detailed Description

Helper class for vtkCompositePolyDataMapper2 that is a subclass of vtkOpenGLPolyDataMapper.

Definition at line 60 of file vtkCompositeMapperHelper2.h.

## Member Typedef Documentation

## ◆ Superclass

typedef vtkOpenGLPolyDataMapper vtkCompositeMapperHelper2::Superclass

Definition at line 66 of file vtkCompositeMapperHelper2.h.

## Constructor & Destructor Documentation

## ◆ vtkCompositeMapperHelper2()

vtkCompositeMapperHelper2::vtkCompositeMapperHelper2 | ( |  | ) |
| inlineprotected

Definition at line 111 of file vtkCompositeMapperHelper2.h.

## ◆ ~vtkCompositeMapperHelper2()

vtkCompositeMapperHelper2::~vtkCompositeMapperHelper2 | ( |  | ) |
| overrideprotected

## Member Function Documentation

## ◆ New()

static vtkCompositeMapperHelper2* vtkCompositeMapperHelper2::New | ( |  | ) |
| static

## ◆ IsTypeOf()

static vtkTypeBool vtkCompositeMapperHelper2::IsTypeOf | ( | const char * | type | ) |
| static

## ◆ IsA()

virtual vtkTypeBool vtkCompositeMapperHelper2::IsA | ( | const char * | type | ) |
| virtual

## ◆ SafeDownCast()

static vtkCompositeMapperHelper2* vtkCompositeMapperHelper2::SafeDownCast | ( | vtkObjectBase * | o | ) |
| static

## ◆ NewInstanceInternal()

virtual vtkObjectBase* vtkCompositeMapperHelper2::NewInstanceInternal | ( |  | ) | const
| protectedvirtual

## ◆ NewInstance()

vtkCompositeMapperHelper2* vtkCompositeMapperHelper2::NewInstance | ( |  | ) | const

## ◆ PrintSelf()

void vtkCompositeMapperHelper2::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) |  |
| override

## ◆ SetParent()

void vtkCompositeMapperHelper2::SetParent | ( | vtkCompositePolyDataMapper2 * | p | ) |
| inline

Definition at line 69 of file vtkCompositeMapperHelper2.h.

## ◆ AddData()

vtkCompositeMapperHelperData* vtkCompositeMapperHelper2::AddData | ( | vtkPolyData * | pd,
|  | unsigned int | flatIndex
| ) |  |

## ◆ RenderPiece()

void vtkCompositeMapperHelper2::RenderPiece | ( | vtkRenderer * | ren,
|  | vtkActor * | act
| ) |  |
| override

Implemented by sub classes.

Actual rendering is done here.

## ◆ ClearMark()

void vtkCompositeMapperHelper2::ClearMark | ( |  | ) |

keep track of what data is being used as the multiblock can change

## ◆ RemoveUnused()

void vtkCompositeMapperHelper2::RemoveUnused | ( |  | ) |

keep track of what data is being used as the multiblock can change

## ◆ GetMarked()

bool vtkCompositeMapperHelper2::GetMarked | ( |  | ) |
| inline

keep track of what data is being used as the multiblock can change

Definition at line 83 of file vtkCompositeMapperHelper2.h.

## ◆ SetMarked()

void vtkCompositeMapperHelper2::SetMarked | ( | bool | v | ) |
| inline

keep track of what data is being used as the multiblock can change

Definition at line 84 of file vtkCompositeMapperHelper2.h.

## ◆ GetRenderedList()

std::vector<vtkPolyData*> vtkCompositeMapperHelper2::GetRenderedList | ( |  | ) | const

Accessor to the ordered list of PolyData that we last drew.

## ◆ ProcessSelectorPixelBuffers()

void vtkCompositeMapperHelper2::ProcessSelectorPixelBuffers | ( | vtkHardwareSelector * | sel,
|  | std::vector< unsigned int > & | pixeloffsets,
|  | vtkProp * | prop
| ) |  |
| override

allows a mapper to update a selections color buffers Called from a prop which in turn is called from the selector

## ◆ ProcessCompositePixelBuffers()

virtual void vtkCompositeMapperHelper2::ProcessCompositePixelBuffers | ( | vtkHardwareSelector * | sel,
|  | vtkProp * | prop,
|  | vtkCompositeMapperHelperData * | hdata,
|  | std::vector< unsigned int > & | mypixels
| ) |  |
| virtual

## ◆ UpdateCameraShiftScale()

void vtkCompositeMapperHelper2::UpdateCameraShiftScale | ( | vtkRenderer * | ren,
|  | vtkActor * | actor
| ) |  |
| overrideprotected

handle updating shift scale based on pose changes

## ◆ DrawIBO()

void vtkCompositeMapperHelper2::DrawIBO | ( | vtkRenderer * | ren,
|  | vtkActor * | actor,
|  | int | primType,
|  | vtkOpenGLHelper & | CellBO,
|  | GLenum | mode,
|  | int | pointSize
| ) |  |
| protected

## ◆ SetShaderValues()

virtual void vtkCompositeMapperHelper2::SetShaderValues | ( | vtkShaderProgram * | prog,
|  | vtkCompositeMapperHelperData * | hdata,
|  | size_t | primOffset
| ) |  |
| protectedvirtual

## ◆ UpdateShaders()

void vtkCompositeMapperHelper2::UpdateShaders | ( | vtkOpenGLHelper & | cellBO,
|  | vtkRenderer * | ren,
|  | vtkActor * | act
| ) |  |
| overrideprotected

Make sure appropriate shaders are defined, compiled and bound.

This method orchistrates the process, much of the work is done in other methods

## ◆ ReplaceShaderColor()

void vtkCompositeMapperHelper2::ReplaceShaderColor | ( | std::map< vtkShader::Type, vtkShader * > | shaders,
|  | vtkRenderer * | ren,
|  | vtkActor * | act
| ) |  |
| overrideprotected

Perform string replacements on the shader templates, called from ReplaceShaderValues.

## ◆ GetNeedToRebuildBufferObjects()

bool vtkCompositeMapperHelper2::GetNeedToRebuildBufferObjects | ( | vtkRenderer * | ren,
|  | vtkActor * | act
| ) |  |
| overrideprotected

Does the VBO/IBO need to be rebuilt.

## ◆ BuildBufferObjects()

void vtkCompositeMapperHelper2::BuildBufferObjects | ( | vtkRenderer * | ren,
|  | vtkActor * | act
| ) |  |
| overrideprotected

Build the VBO/IBO, called by UpdateBufferObjects.

## ◆ AppendOneBufferObject()

virtual void vtkCompositeMapperHelper2::AppendOneBufferObject | ( | vtkRenderer * | ren,
|  | vtkActor * | act,
|  | vtkCompositeMapperHelperData * | hdata,
|  | vtkIdType & | flat_index,
|  | std::vector< unsigned char > & | colors,
|  | std::vector< float > & | norms
| ) |  |
| protectedvirtual

## ◆ BuildSelectionIBO()

void vtkCompositeMapperHelper2::BuildSelectionIBO | ( | vtkPolyData * | poly,
|  | std::vector< unsigned int >(&) | indices[4],
|  | vtkIdType | offset
| ) |  |
| overrideprotected

Build the selection IBOs, called by UpdateBufferObjects.

## ◆ CanUseTextureMapForColoring()

int vtkCompositeMapperHelper2::CanUseTextureMapForColoring | ( | vtkDataObject * |  | ) |
| overrideprotected

Returns if we can use texture maps for scalar coloring.

Note this doesn't say we "will" use scalar coloring. It says, if we do use scalar coloring, we will use a texture. Always off for this mapper.

## ◆ RenderPieceDraw()

void vtkCompositeMapperHelper2::RenderPieceDraw | ( | vtkRenderer * | ren,
|  | vtkActor * | act
| ) |  |
| overrideprotected

## Member Data Documentation

## ◆ Parent

vtkCompositePolyDataMapper2* vtkCompositeMapperHelper2::Parent
| protected

Definition at line 103 of file vtkCompositeMapperHelper2.h.

## ◆ Data

std::map<vtkPolyData*, vtkCompositeMapperHelperData*> vtkCompositeMapperHelper2::Data
| protected

Definition at line 104 of file vtkCompositeMapperHelper2.h.

## ◆ Marked

bool vtkCompositeMapperHelper2::Marked
| protected

Definition at line 106 of file vtkCompositeMapperHelper2.h.

## ◆ VertexOffsets

std::vector<unsigned int> vtkCompositeMapperHelper2::VertexOffsets
| protected

Definition at line 159 of file vtkCompositeMapperHelper2.h.

## ◆ IndexArray

std::vector<unsigned int> vtkCompositeMapperHelper2::IndexArray[PrimitiveEnd]
| protected

Definition at line 162 of file vtkCompositeMapperHelper2.h.

## ◆ PrimIDUsed

bool vtkCompositeMapperHelper2::PrimIDUsed
| protected

Definition at line 166 of file vtkCompositeMapperHelper2.h.

## ◆ OverideColorUsed

bool vtkCompositeMapperHelper2::OverideColorUsed
| protected

Definition at line 167 of file vtkCompositeMapperHelper2.h.

## ◆ CurrentSelector

vtkHardwareSelector* vtkCompositeMapperHelper2::CurrentSelector
| protected

Definition at line 169 of file vtkCompositeMapperHelper2.h.

## ◆ PickPixels

std::vector<std::vector<unsigned int> > vtkCompositeMapperHelper2::PickPixels
| protected

used by the hardware selector

Definition at line 172 of file vtkCompositeMapperHelper2.h.

## ◆ ColorArrayMap

std::map<vtkAbstractArray*, vtkDataArray*> vtkCompositeMapperHelper2::ColorArrayMap
| protected

Definition at line 174 of file vtkCompositeMapperHelper2.h.

The documentation for this class was generated from the following file:

- Rendering/OpenGL2/vtkCompositeMapperHelper2.h